Index: CONFIG/IPSLCM/IPSLCM5/branches/IPSLCM5_v2/scripts/BB_make
===================================================================
--- CONFIG/IPSLCM/IPSLCM5/branches/IPSLCM5_v2/scripts/BB_make	(revision 704)
+++ CONFIG/IPSLCM/IPSLCM5/branches/IPSLCM5_v2/scripts/BB_make	(revision 705)
@@ -7646,6 +7516,6 @@
 	$(MODEL_LIB)(zdfmxl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	$(MODEL_LIB)(zdftke2.o) \
 	$(MODEL_LIB)(zdftke.o) \
+	$(MODEL_LIB)(zdftke_old.o) \
 	$(MODEL_LIB)(zpshde.o) \
 	obctra.F90 \
@@ -7671,5 +7541,4 @@
 	sbcssm.F90 \
 	sbcssr.F90 \
-	solisl.F90 \
 	sol_oce.F90 \
 	traqsr.F90 \
@@ -7684,6 +7553,6 @@
 	zdfmxl.F90 \
 	zdf_oce.F90 \
-	zdftke2.F90 \
 	zdftke.F90 \
+	zdftke_old.F90 \
 	zpshde.F90 \
 	daymod.F90 \
@@ -7697,5 +7566,4 @@
 	dynzdf.F90 \
 	eosbn2.F90 \
-	ice_oce.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -7711,5 +7579,4 @@
 	$(MODEL_LIB)(dynzdf.o) \
 	$(MODEL_LIB)(eosbn2.o) \
-	$(MODEL_LIB)(ice_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -7726,5 +7593,4 @@
 	$(MODEL_LIB)(trasbc.o) \
 	$(MODEL_LIB)(trazdf.o) \
-	$(MODEL_LIB)(trcstp.o) \
 	$(MODEL_LIB)(zdfbfr.o) \
 	$(MODEL_LIB)(zdfddm.o) \
@@ -7746,5 +7612,4 @@
 	trasbc.F90 \
 	trazdf.F90 \
-	trcstp.F90 \
 	zdfbfr.F90 \
 	zdfddm.F90 \
@@ -7769,4 +7634,5 @@
 	bdytra.F90 \
 	c1d.F90 \
+	cla_div.F90 \
 	closea.F90 \
 	cpl_oasis3.F90 \
@@ -7775,6 +7641,5 @@
 	diahth.F90 \
 	dianam.F90 \
-	diaspr.F90 \
-	diawri.F90 \
+	divcur.F90 \
 	dom_oce.F90 \
 	domvvl.F90 \
@@ -7784,4 +7649,5 @@
 	dynadv.F90 \
 	dynadv_ubs.F90 \
+	dynhpg.F90 \
 	dynkeg.F90 \
 	dynldf_bilap.F90 \
@@ -7792,5 +7658,4 @@
 	dynspg_flt.F90 \
 	dynspg_oce.F90 \
-	dynspg_rl.F90 \
 	dynspg_ts.F90 \
 	dynzad.F90 \
@@ -7806,5 +7671,4 @@
 	geo2ocean.F90 \
 	ice_2.F90 \
-	ice_oce.F90 \
 	in_out_manager.F90 \
 	iom_def.F90 \
@@ -7814,4 +7678,5 @@
 	iom_rstdimg.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfdyn_oce.F90 \
 	ldfslp.F90 \
@@ -7819,4 +7684,5 @@
 	lib_mpp.F90 \
 	lib_print.f90 \
+	limwri_2.F90 \
 	$(MODEL_LIB)(agrif_opa_interp.o) \
 	$(MODEL_LIB)(agrif_opa_update.o) \
@@ -7828,4 +7694,5 @@
 	$(MODEL_LIB)(bdytra.o) \
 	$(MODEL_LIB)(c1d.o) \
+	$(MODEL_LIB)(cla_div.o) \
 	$(MODEL_LIB)(closea.o) \
 	$(MODEL_LIB)(cpl_oasis3.o) \
@@ -7834,6 +7701,5 @@
 	$(MODEL_LIB)(diahth.o) \
 	$(MODEL_LIB)(dianam.o) \
-	$(MODEL_LIB)(diaspr.o) \
-	$(MODEL_LIB)(diawri.o) \
+	$(MODEL_LIB)(divcur.o) \
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(domvvl.o) \
@@ -7843,4 +7709,5 @@
 	$(MODEL_LIB)(dynadv.o) \
 	$(MODEL_LIB)(dynadv_ubs.o) \
+	$(MODEL_LIB)(dynhpg.o) \
 	$(MODEL_LIB)(dynkeg.o) \
 	$(MODEL_LIB)(dynldf_bilapg.o) \
@@ -7851,5 +7718,4 @@
 	$(MODEL_LIB)(dynspg_flt.o) \
 	$(MODEL_LIB)(dynspg_oce.o) \
-	$(MODEL_LIB)(dynspg_rl.o) \
 	$(MODEL_LIB)(dynspg_ts.o) \
 	$(MODEL_LIB)(dynzad.o) \
@@ -7865,5 +7731,4 @@
 	$(MODEL_LIB)(geo2ocean.o) \
 	$(MODEL_LIB)(ice_2.o) \
-	$(MODEL_LIB)(ice_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom_def.o) \
@@ -7873,4 +7738,5 @@
 	$(MODEL_LIB)(iom_rstdimg.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldfslp.o) \
@@ -7878,5 +7744,5 @@
 	$(MODEL_LIB)(lib_mpp.o) \
 	$(MODEL_LIB)(lib_print.o) \
-	$(MODEL_LIB)(obccli.o) \
+	$(MODEL_LIB)(limwri_2.o) \
 	$(MODEL_LIB)(obcdyn_bt.o) \
 	$(MODEL_LIB)(obcdyn.o) \
@@ -7886,4 +7752,5 @@
 	$(MODEL_LIB)(obcvol.o) \
 	$(MODEL_LIB)(oce.o) \
+	$(MODEL_LIB)(par_ice_2.o) \
 	$(MODEL_LIB)(par_kind.o) \
 	$(MODEL_LIB)(par_oce.o) \
@@ -7905,9 +7772,5 @@
 	$(MODEL_LIB)(sbcssm.o) \
 	$(MODEL_LIB)(sbcssr.o) \
-	$(MODEL_LIB)(solfet.o) \
-	$(MODEL_LIB)(solisl.o) \
 	$(MODEL_LIB)(sol_oce.o) \
-	$(MODEL_LIB)(solpcg.o) \
-	$(MODEL_LIB)(solsor.o) \
 	$(MODEL_LIB)(traadv_cen2.o) \
 	$(MODEL_LIB)(traadv_eiv.o) \
@@ -7937,8 +7800,7 @@
 	$(MODEL_LIB)(zdfmxl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	$(MODEL_LIB)(zdftke2.o) \
 	$(MODEL_LIB)(zdftke.o) \
+	$(MODEL_LIB)(zdftke_old.o) \
 	$(MODEL_LIB)(zpshde.o) \
-	obccli.F90 \
 	obcdyn_bt.F90 \
 	obcdyn.F90 \
@@ -7948,4 +7810,5 @@
 	obcvol.F90 \
 	oce.F90 \
+	par_ice_2.F90 \
 	par_kind.F90 \
 	par_oce.F90 \
@@ -7967,9 +7830,5 @@
 	sbcssm.F90 \
 	sbcssr.F90 \
-	solfet.F90 \
-	solisl.F90 \
 	sol_oce.F90 \
-	solpcg.F90 \
-	solsor.F90 \
 	traadv_cen2.F90 \
 	traadv_eiv.F90 \
@@ -7999,11 +7858,10 @@
 	zdfmxl.F90 \
 	zdf_oce.F90 \
-	zdftke2.F90 \
 	zdftke.F90 \
+	zdftke_old.F90 \
 	zpshde.F90 \
 	agrif_opa_sponge.F90 \
 	bdydta.F90 \
 	bdy_par.F90 \
-	cla_div.F90 \
 	cla.F90 \
 	cpl_oasis3.F90 \
@@ -8014,9 +7872,6 @@
 	diahth.F90 \
 	diaptr.F90 \
-	diaspr.F90 \
 	diawri.F90 \
-	divcur.F90 \
-	dom_oce.F90 \
-	domvvl.F90 \
+	dom_oce.F90 \
 	dtasal.F90 \
 	dtatem.F90 \
@@ -8032,5 +7887,4 @@
 	floats.F90 \
 	flo_oce.F90 \
-	ice_oce.F90 \
 	in_out_manager.F90 \
 	iom.F90 \
@@ -8043,5 +7897,4 @@
 	$(MODEL_LIB)(bdydta.o) \
 	$(MODEL_LIB)(bdy_par.o) \
-	$(MODEL_LIB)(cla_div.o) \
 	$(MODEL_LIB)(cla.o) \
 	$(MODEL_LIB)(cpl_oasis3.o) \
@@ -8052,9 +7905,6 @@
 	$(MODEL_LIB)(diahth.o) \
 	$(MODEL_LIB)(diaptr.o) \
-	$(MODEL_LIB)(diaspr.o) \
 	$(MODEL_LIB)(diawri.o) \
-	$(MODEL_LIB)(divcur.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(domvvl.o) \
+	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(dtasal.o) \
 	$(MODEL_LIB)(dtatem.o) \
@@ -8070,5 +7920,4 @@
 	$(MODEL_LIB)(floats.o) \
 	$(MODEL_LIB)(flo_oce.o) \
-	$(MODEL_LIB)(ice_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
@@ -8082,5 +7931,4 @@
 	$(MODEL_LIB)(obcrad.o) \
 	$(MODEL_LIB)(obcrst.o) \
-	$(MODEL_LIB)(obcspg.o) \
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(prtctl.o) \
@@ -8089,4 +7937,5 @@
 	$(MODEL_LIB)(sbcmod.o) \
 	$(MODEL_LIB)(sbcrnf.o) \
+	$(MODEL_LIB)(sshwzv.o) \
 	$(MODEL_LIB)(stpctl.o) \
 	$(MODEL_LIB)(traadv.o) \
@@ -8100,5 +7949,4 @@
 	$(MODEL_LIB)(trasbc.o) \
 	$(MODEL_LIB)(trazdf.o) \
-	$(MODEL_LIB)(trcstp.o) \
 	$(MODEL_LIB)(trdicp.o) \
 	$(MODEL_LIB)(trdmld.o) \
@@ -8106,5 +7954,4 @@
 	$(MODEL_LIB)(trdmod_oce.o) \
 	$(MODEL_LIB)(trdvor.o) \
-	$(MODEL_LIB)(wzvmod.o) \
 	$(MODEL_LIB)(zdfbfr.o) \
 	$(MODEL_LIB)(zdfddm.o) \
@@ -8114,6 +7961,7 @@
 	$(MODEL_LIB)(zdf_oce.o) \
 	$(MODEL_LIB)(zdfric.o) \
-	$(MODEL_LIB)(zdftke2.o) \
 	$(MODEL_LIB)(zdftke.o) \
+	$(MODEL_LIB)(zdftke_old.o) \
+	$(MODEL_LIB)(zdftmx.o) \
 	$(MODEL_LIB)(zpshde.o) \
 	obcdta.F90 \
@@ -8121,5 +7969,4 @@
 	obcrad.F90 \
 	obcrst.F90 \
-	obcspg.F90 \
 	oce.F90 \
 	prtctl.F90 \
@@ -8128,4 +7975,5 @@
 	sbcmod.F90 \
 	sbcrnf.F90 \
+	sshwzv.F90 \
 	stpctl.F90 \
 	traadv.F90 \
@@ -8139,5 +7987,4 @@
 	trasbc.F90 \
 	trazdf.F90 \
-	trcstp.F90 \
 	trdicp.F90 \
 	trdmld.F90 \
@@ -8145,5 +7992,4 @@
 	trdmod_oce.F90 \
 	trdvor.F90 \
-	wzvmod.F90 \
 	zdfbfr.F90 \
 	zdfddm.F90 \
@@ -8153,6 +7999,7 @@
 	zdf_oce.F90 \
 	zdfric.F90 \
-	zdftke2.F90 \
 	zdftke.F90 \
+	zdftke_old.F90 \
+	zdftmx.F90 \
 	zpshde.F90 \
 	domzgr_substitute.h90 \
@@ -8162,79 +8009,33 @@
 	step.F90
 $(MODEL_LIB)(stpctl.o) :	\
-	daymod.F90 \
-	diadimg.F90 \
-	diahth.F90 \
-	dianam.F90 \
-	diaspr.F90 \
-	dom_oce.F90 \
-	ice_oce.F90 \
-	in_out_manager.F90 \
-	iom.F90 \
-	lbclnk.F90 \
-	ldfdyn_oce.F90 \
-	ldftra_oce.F90 \
-	lib_mpp.F90 \
-	lib_print.f90 \
-	$(MODEL_LIB)(daymod.o) \
-	$(MODEL_LIB)(diadimg.o) \
-	$(MODEL_LIB)(diahth.o) \
-	$(MODEL_LIB)(dianam.o) \
-	$(MODEL_LIB)(diaspr.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(ice_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(iom.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(ldfdyn_oce.o) \
-	$(MODEL_LIB)(ldftra_oce.o) \
-	$(MODEL_LIB)(lib_mpp.o) \
-	$(MODEL_LIB)(lib_print.o) \
-	$(MODEL_LIB)(obc_oce.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(sbc_ice.o) \
-	$(MODEL_LIB)(sbc_oce.o) \
-	$(MODEL_LIB)(sbcssr.o) \
-	$(MODEL_LIB)(solfet.o) \
+	dom_oce.F90 \
+	in_out_manager.F90 \
+	lbcnfd.F90 \
+	lib_mpp.F90 \
+	lib_print.f90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
+	$(MODEL_LIB)(lib_mpp.o) \
+	$(MODEL_LIB)(lib_print.o) \
+	$(MODEL_LIB)(oce.o) \
+	$(MODEL_LIB)(par_kind.o) \
+	$(MODEL_LIB)(par_oce.o) \
+	oce.F90 \
+	par_kind.F90 \
+	par_oce.F90 \
+	dom_oce.F90 \
+	dynspg_oce.F90 \
+	in_out_manager.F90 \
+	lbclnk.F90 \
+	lib_mpp.F90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(dynspg_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lib_mpp.o) \
+	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(sol_oce.o) \
-	$(MODEL_LIB)(solpcg.o) \
-	$(MODEL_LIB)(solsor.o) \
-	$(MODEL_LIB)(zdfddm.o) \
-	$(MODEL_LIB)(zdfmxl.o) \
-	$(MODEL_LIB)(zdf_oce.o) \
-	obc_oce.F90 \
-	oce.F90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	sbc_ice.F90 \
-	sbc_oce.F90 \
-	sbcssr.F90 \
-	solfet.F90 \
-	sol_oce.F90 \
-	solpcg.F90 \
-	solsor.F90 \
-	zdfddm.F90 \
-	zdfmxl.F90 \
-	zdf_oce.F90 \
-	diawri.F90 \
-	dom_oce.F90 \
-	dynspg_oce.F90 \
-	in_out_manager.F90 \
-	lbclnk.F90 \
-	lib_mpp.F90 \
-	$(MODEL_LIB)(diawri.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(dynspg_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(lib_mpp.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(solisl.o) \
-	$(MODEL_LIB)(sol_oce.o) \
-	oce.F90 \
-	solisl.F90 \
+	oce.F90 \
 	sol_oce.F90 \
 	stpctl.F90
@@ -8247,4 +8048,5 @@
 	thd_ice_2.F90
 $(MODEL_LIB)(traadv_cen2.o) :	\
+	c1d.F90 \
 	closea.F90 \
 	cpl_oasis3.F90 \
@@ -8254,11 +8056,16 @@
 	eosbn2.F90 \
 	fldread.F90 \
-	ice_oce.F90 \
-	in_out_manager.F90 \
-	iom.F90 \
-	lbclnk.F90 \
+	in_out_manager.F90 \
+	iom_def.F90 \
+	iom.F90 \
+	iom_ioipsl.F90 \
+	iom_nf90.F90 \
+	iom_rstdimg.F90 \
+	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
 	lib_print.f90 \
+	$(MODEL_LIB)(c1d.o) \
 	$(MODEL_LIB)(closea.o) \
 	$(MODEL_LIB)(cpl_oasis3.o) \
@@ -8268,8 +8075,12 @@
 	$(MODEL_LIB)(eosbn2.o) \
 	$(MODEL_LIB)(fldread.o) \
-	$(MODEL_LIB)(ice_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(iom.o) \
-	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom_def.o) \
+	$(MODEL_LIB)(iom_ioipsl.o) \
+	$(MODEL_LIB)(iom_nf90.o) \
+	$(MODEL_LIB)(iom.o) \
+	$(MODEL_LIB)(iom_rstdimg.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -8290,4 +8101,5 @@
 	$(MODEL_LIB)(sbcice_lim_2.o) \
 	$(MODEL_LIB)(sbcice_lim.o) \
+	$(MODEL_LIB)(sbc_ice.o) \
 	$(MODEL_LIB)(sbc_oce.o) \
 	$(MODEL_LIB)(sbcrnf.o) \
@@ -8303,5 +8115,7 @@
 	$(MODEL_LIB)(trdvor_oce.o) \
 	$(MODEL_LIB)(zdfddm.o) \
+	$(MODEL_LIB)(zdfmxl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
+	$(MODEL_LIB)(zpshde.o) \
 	oce.F90 \
 	par_kind.F90 \
@@ -8316,4 +8130,5 @@
 	sbcflx.F90 \
 	sbcfwb.F90 \
+	sbc_ice.F90 \
 	sbcice_if.F90 \
 	sbcice_lim_2.F90 \
@@ -8332,5 +8147,7 @@
 	trdvor_oce.F90 \
 	zdfddm.F90 \
+	zdfmxl.F90 \
 	zdf_oce.F90 \
+	zpshde.F90 \
 	closea.F90 \
 	diaptr.F90 \
@@ -8339,4 +8156,5 @@
 	eosbn2.F90 \
 	in_out_manager.F90 \
+	iom.F90 \
 	lbclnk.F90 \
 	lib_mpp.F90 \
@@ -8347,8 +8165,10 @@
 	$(MODEL_LIB)(eosbn2.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(lib_mpp.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(prtctl.o) \
+	$(MODEL_LIB)(iom.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lib_mpp.o) \
+	$(MODEL_LIB)(oce.o) \
+	$(MODEL_LIB)(prtctl.o) \
+	$(MODEL_LIB)(restart.o) \
 	$(MODEL_LIB)(sbcmod.o) \
 	$(MODEL_LIB)(sbc_oce.o) \
@@ -8360,4 +8180,5 @@
 	oce.F90 \
 	prtctl.F90 \
+	restart.F90 \
 	sbcmod.F90 \
 	sbc_oce.F90 \
@@ -8374,4 +8195,8 @@
 	dom_oce.F90 \
 	in_out_manager.F90 \
+	iom_def.F90 \
+	iom_ioipsl.F90 \
+	iom_nf90.F90 \
+	iom_rstdimg.F90 \
 	lbclnk.F90 \
 	ldfdyn_oce.F90 \
@@ -8380,4 +8205,8 @@
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom_def.o) \
+	$(MODEL_LIB)(iom_ioipsl.o) \
+	$(MODEL_LIB)(iom_nf90.o) \
+	$(MODEL_LIB)(iom_rstdimg.o) \
 	$(MODEL_LIB)(lbclnk.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
@@ -8398,8 +8227,10 @@
 	dom_oce.F90 \
 	in_out_manager.F90 \
+	iom.F90 \
 	ldfslp.F90 \
 	ldftra_oce.F90 \
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(ldfslp.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
@@ -8419,4 +8250,9 @@
 	eosbn2.F90 \
 	in_out_manager.F90 \
+	iom_def.F90 \
+	iom.F90 \
+	iom_ioipsl.F90 \
+	iom_nf90.F90 \
+	iom_rstdimg.F90 \
 	lbclnk.F90 \
 	ldfslp.F90 \
@@ -8430,4 +8266,9 @@
 	$(MODEL_LIB)(eosbn2.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom_def.o) \
+	$(MODEL_LIB)(iom_ioipsl.o) \
+	$(MODEL_LIB)(iom_nf90.o) \
+	$(MODEL_LIB)(iom.o) \
+	$(MODEL_LIB)(iom_rstdimg.o) \
 	$(MODEL_LIB)(lbclnk.o) \
 	$(MODEL_LIB)(ldfslp.o) \
@@ -8439,4 +8280,5 @@
 	$(MODEL_LIB)(par_oce.o) \
 	$(MODEL_LIB)(prtctl.o) \
+	$(MODEL_LIB)(restart.o) \
 	$(MODEL_LIB)(sbcmod.o) \
 	$(MODEL_LIB)(sbc_oce.o) \
@@ -8450,4 +8292,5 @@
 	par_oce.F90 \
 	prtctl.F90 \
+	restart.F90 \
 	sbcmod.F90 \
 	sbc_oce.F90 \
@@ -8459,7 +8302,9 @@
 	dom_oce.F90 \
 	in_out_manager.F90 \
+	iom.F90 \
 	ldftra_oce.F90 \
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(oce.o) \
@@ -8495,4 +8340,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -8505,4 +8351,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -8572,4 +8419,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -8582,4 +8430,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -8649,4 +8498,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -8659,4 +8509,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -8726,4 +8577,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -8736,4 +8588,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -8801,4 +8654,5 @@
 	in_out_manager.F90 \
 	iom.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -8809,4 +8663,5 @@
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -8931,4 +8786,5 @@
 	dom_oce.F90 \
 	in_out_manager.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -8936,4 +8792,5 @@
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -8986,5 +8843,7 @@
 	trdmod_oce.F90 \
 	eosbn2.F90 \
+	iom.F90 \
 	$(MODEL_LIB)(eosbn2.o) \
+	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(oce.o) \
 	oce.F90 \
@@ -9004,4 +8863,5 @@
 	iom_rstdimg.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -9016,4 +8876,5 @@
 	$(MODEL_LIB)(iom_rstdimg.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -9085,4 +8946,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfdyn_oce.F90 \
 	ldftra_oce.F90 \
@@ -9095,4 +8957,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
@@ -9162,4 +9025,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfdyn_oce.F90 \
 	ldftra_oce.F90 \
@@ -9172,4 +9036,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
@@ -9238,4 +9103,5 @@
 	in_out_manager.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfdyn_oce.F90 \
 	ldfslp.F90 \
@@ -9249,4 +9115,5 @@
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldfslp.o) \
@@ -9273,6 +9140,6 @@
 	$(MODEL_LIB)(zdfmxl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	$(MODEL_LIB)(zdftke2.o) \
 	$(MODEL_LIB)(zdftke.o) \
+	$(MODEL_LIB)(zdftke_old.o) \
 	oce.F90 \
 	par_kind.F90 \
@@ -9294,6 +9161,6 @@
 	zdfmxl.F90 \
 	zdf_oce.F90 \
-	zdftke2.F90 \
 	zdftke.F90 \
+	zdftke_old.F90 \
 	dom_oce.F90 \
 	in_out_manager.F90 \
@@ -9479,4 +9346,5 @@
 	dom_oce.F90 \
 	in_out_manager.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -9484,4 +9352,5 @@
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
@@ -9528,7 +9397,9 @@
 	$(MODEL_LIB)(trdmod.o) \
 	$(MODEL_LIB)(trdmod_oce.o) \
+	$(MODEL_LIB)(zdf_oce.o) \
 	oce.F90 \
 	trdmod.F90 \
 	trdmod_oce.F90 \
+	zdf_oce.F90 \
 	domzgr_substitute.h90 \
 	KEY_CPP \
@@ -9539,4 +9410,5 @@
 	in_out_manager.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -9546,8 +9418,103 @@
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
 	$(MODEL_LIB)(lib_print.o) \
 	$(MODEL_LIB)(obc_oce.o) \
+	$(MODEL_LIB)(oce.o) \
+	$(MODEL_LIB)(par_kind.o) \
+	$(MODEL_LIB)(par_oce.o) \
+	$(MODEL_LIB)(phycst.o) \
+	$(MODEL_LIB)(prtctl.o) \
+	$(MODEL_LIB)(sbc_oce.o) \
+	$(MODEL_LIB)(trdicp.o) \
+	$(MODEL_LIB)(trdicp_oce.o) \
+	$(MODEL_LIB)(trdmld.o) \
+	$(MODEL_LIB)(trdmld_oce.o) \
+	$(MODEL_LIB)(trdmod.o) \
+	$(MODEL_LIB)(trdmod_oce.o) \
+	$(MODEL_LIB)(trdvor.o) \
+	$(MODEL_LIB)(trdvor_oce.o) \
+	$(MODEL_LIB)(zdf_oce.o) \
+	obc_oce.F90 \
+	oce.F90 \
+	par_kind.F90 \
+	par_oce.F90 \
+	phycst.F90 \
+	prtctl.F90 \
+	sbc_oce.F90 \
+	trdicp.F90 \
+	trdicp_oce.F90 \
+	trdmld.F90 \
+	trdmld_oce.F90 \
+	trdmod.F90 \
+	trdmod_oce.F90 \
+	trdvor.F90 \
+	trdvor_oce.F90 \
+	zdf_oce.F90 \
+	agrif_opa_interp.F90 \
+	agrif_opa_update.F90 \
+	bdytra.F90 \
+	dom_oce.F90 \
+	domvvl.F90 \
+	dynhpg.F90 \
+	dynspg_oce.F90 \
+	in_out_manager.F90 \
+	lbclnk.F90 \
+	$(MODEL_LIB)(agrif_opa_interp.o) \
+	$(MODEL_LIB)(agrif_opa_update.o) \
+	$(MODEL_LIB)(bdytra.o) \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(domvvl.o) \
+	$(MODEL_LIB)(dynhpg.o) \
+	$(MODEL_LIB)(dynspg_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(obctra.o) \
+	$(MODEL_LIB)(oce.o) \
+	$(MODEL_LIB)(phycst.o) \
+	$(MODEL_LIB)(prtctl.o) \
+	$(MODEL_LIB)(trdmod.o) \
+	$(MODEL_LIB)(trdmod_oce.o) \
+	$(MODEL_LIB)(zdf_oce.o) \
+	obctra.F90 \
+	oce.F90 \
+	phycst.F90 \
+	prtctl.F90 \
+	trdmod.F90 \
+	trdmod_oce.F90 \
+	zdf_oce.F90 \
+	domzgr_substitute.h90 \
+	$(AGRIF_LIB) \
+	KEY_CPP \
+	tranxt.F90
+$(MODEL_LIB)(traqsr.o) :	\
+	daymod.F90 \
+	dom_oce.F90 \
+	geo2ocean.F90 \
+	in_out_manager.F90 \
+	iom_def.F90 \
+	iom.F90 \
+	iom_ioipsl.F90 \
+	iom_nf90.F90 \
+	iom_rstdimg.F90 \
+	lbclnk.F90 \
+	ldftra_oce.F90 \
+	lib_mpp.F90 \
+	lib_print.f90 \
+	$(MODEL_LIB)(daymod.o) \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(geo2ocean.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom_def.o) \
+	$(MODEL_LIB)(iom_ioipsl.o) \
+	$(MODEL_LIB)(iom_nf90.o) \
+	$(MODEL_LIB)(iom.o) \
+	$(MODEL_LIB)(iom_rstdimg.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(ldftra_oce.o) \
+	$(MODEL_LIB)(lib_mpp.o) \
+	$(MODEL_LIB)(lib_print.o) \
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(par_kind.o) \
@@ -9563,5 +9530,4 @@
 	$(MODEL_LIB)(trdvor_oce.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	obc_oce.F90 \
 	oce.F90 \
 	par_kind.F90 \
@@ -9577,79 +9543,12 @@
 	trdvor_oce.F90 \
 	zdf_oce.F90 \
-	agrif_opa_interp.F90 \
-	agrif_opa_update.F90 \
-	bdytra.F90 \
-	dom_oce.F90 \
-	dynspg_oce.F90 \
-	in_out_manager.F90 \
-	lbclnk.F90 \
-	$(MODEL_LIB)(agrif_opa_interp.o) \
-	$(MODEL_LIB)(agrif_opa_update.o) \
-	$(MODEL_LIB)(bdytra.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(dynspg_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(obctra.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(prtctl.o) \
-	$(MODEL_LIB)(trdmod.o) \
-	$(MODEL_LIB)(trdmod_oce.o) \
-	$(MODEL_LIB)(zdf_oce.o) \
-	obctra.F90 \
-	oce.F90 \
-	phycst.F90 \
-	prtctl.F90 \
-	trdmod.F90 \
-	trdmod_oce.F90 \
-	zdf_oce.F90 \
-	domzgr_substitute.h90 \
-	$(AGRIF_LIB) \
-	KEY_CPP \
-	tranxt.F90
-$(MODEL_LIB)(traqsr.o) :	\
-	dom_oce.F90 \
-	in_out_manager.F90 \
-	lbclnk.F90 \
-	ldftra_oce.F90 \
-	lib_mpp.F90 \
-	lib_print.f90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(ldftra_oce.o) \
-	$(MODEL_LIB)(lib_mpp.o) \
-	$(MODEL_LIB)(lib_print.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(sbc_oce.o) \
-	$(MODEL_LIB)(trdicp.o) \
-	$(MODEL_LIB)(trdicp_oce.o) \
-	$(MODEL_LIB)(trdmld.o) \
-	$(MODEL_LIB)(trdmld_oce.o) \
-	$(MODEL_LIB)(trdmod_oce.o) \
-	$(MODEL_LIB)(trdvor.o) \
-	$(MODEL_LIB)(trdvor_oce.o) \
-	$(MODEL_LIB)(zdf_oce.o) \
-	oce.F90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	sbc_oce.F90 \
-	trdicp.F90 \
-	trdicp_oce.F90 \
-	trdmld.F90 \
-	trdmld_oce.F90 \
-	trdmod_oce.F90 \
-	trdvor.F90 \
-	trdvor_oce.F90 \
-	zdf_oce.F90 \
-	dom_oce.F90 \
-	in_out_manager.F90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
+	dom_oce.F90 \
+	fldread.F90 \
+	in_out_manager.F90 \
+	iom.F90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(fldread.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(phycst.o) \
@@ -9672,5 +9571,7 @@
 $(MODEL_LIB)(trasbc.o) :	\
 	dom_oce.F90 \
-	in_out_manager.F90 \
+	fldread.F90 \
+	in_out_manager.F90 \
+	iom.F90 \
 	lbclnk.F90 \
 	ldftra_oce.F90 \
@@ -9678,5 +9579,7 @@
 	lib_print.f90 \
 	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(fldread.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
@@ -9738,7 +9641,5 @@
 	trasbc.F90
 $(MODEL_LIB)(trazdf_exp.o) :	\
-	bdy_oce.F90 \
-	dom_oce.F90 \
-	dynspg_oce.F90 \
+	dom_oce.F90 \
 	in_out_manager.F90 \
 	lbclnk.F90 \
@@ -9746,7 +9647,5 @@
 	lib_mpp.F90 \
 	lib_print.f90 \
-	$(MODEL_LIB)(bdy_oce.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(dynspg_oce.o) \
+	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(lbclnk.o) \
@@ -9806,8 +9705,6 @@
 	trazdf_exp.F90
 $(MODEL_LIB)(trazdf.o) :	\
-	bdy_oce.F90 \
 	dom_oce.F90 \
 	domvvl.F90 \
-	dynspg_oce.F90 \
 	dynzdf_exp.F90 \
 	eosbn2.F90 \
@@ -9815,4 +9712,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfslp.F90 \
 	ldftra.F90 \
@@ -9820,8 +9718,6 @@
 	lib_mpp.F90 \
 	lib_print.f90 \
-	$(MODEL_LIB)(bdy_oce.o) \
 	$(MODEL_LIB)(dom_oce.o) \
 	$(MODEL_LIB)(domvvl.o) \
-	$(MODEL_LIB)(dynspg_oce.o) \
 	$(MODEL_LIB)(dynzdf_exp.o) \
 	$(MODEL_LIB)(eosbn2.o) \
@@ -9829,4 +9725,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfslp.o) \
 	$(MODEL_LIB)(ldftra.o) \
@@ -9894,6 +9791,6 @@
 	$(MODEL_LIB)(zdfkpp.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	$(MODEL_LIB)(zdftke2.o) \
 	$(MODEL_LIB)(zdftke.o) \
+	$(MODEL_LIB)(zdftke_old.o) \
 	oce.F90 \
 	phycst.F90 \
@@ -9906,6 +9803,6 @@
 	zdfkpp.F90 \
 	zdf_oce.F90 \
-	zdftke2.F90 \
 	zdftke.F90 \
+	zdftke_old.F90 \
 	domzgr_substitute.h90 \
 	vectopt_loop_substitute.h90 \
@@ -9914,9 +9811,8 @@
 	trazdf.F90
 $(MODEL_LIB)(trazdf_imp.o) :	\
-	bdy_oce.F90 \
-	dom_oce.F90 \
-	dynspg_oce.F90 \
-	in_out_manager.F90 \
-	lbclnk.F90 \
+	dom_oce.F90 \
+	in_out_manager.F90 \
+	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfdyn_oce.F90 \
 	ldfslp.F90 \
@@ -9924,9 +9820,8 @@
 	lib_mpp.F90 \
 	lib_print.f90 \
-	$(MODEL_LIB)(bdy_oce.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(dynspg_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldfslp.o) \
@@ -9996,21 +9891,28 @@
 	KEY_CPP \
 	trazdf_imp.F90
-$(MODEL_LIB)(trcini.o) :	\
-	trcini.F90
 $(MODEL_LIB)(trc_oce.o) :	\
-	$(MODEL_LIB)(par_kind.o) \
-	par_kind.F90 \
-	$(MODEL_LIB)(par_oce.o) \
-	par_oce.F90 \
+	lib_print.f90 \
+	$(MODEL_LIB)(lib_print.o) \
+	$(MODEL_LIB)(par_kind.o) \
+	$(MODEL_LIB)(par_oce.o) \
+	par_kind.F90 \
+	par_oce.F90 \
+	dom_oce.F90 \
+	in_out_manager.F90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(par_oce.o) \
+	par_oce.F90 \
+	domzgr_substitute.h90 \
 	KEY_CPP \
 	trc_oce.F90
-$(MODEL_LIB)(trcstp.o) :	\
-	trcstp.F90
 $(MODEL_LIB)(trdicp.o) :	\
 	dom_oce.F90 \
 	in_out_manager.F90 \
-	lib_print.f90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
+	lbcnfd.F90 \
+	lib_print.f90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(lib_print.o) \
 	$(MODEL_LIB)(par_kind.o) \
@@ -10069,4 +9971,5 @@
 	iom.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfdyn_oce.F90 \
 	ldftra_oce.F90 \
@@ -10080,4 +9983,5 @@
 	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
@@ -10094,4 +9998,5 @@
 	$(MODEL_LIB)(trdmod_oce.o) \
 	$(MODEL_LIB)(trdvor_oce.o) \
+	$(MODEL_LIB)(zdfddm.o) \
 	$(MODEL_LIB)(zdfmxl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
@@ -10107,4 +10012,5 @@
 	trdmod_oce.F90 \
 	trdvor_oce.F90 \
+	zdfddm.F90 \
 	zdfmxl.F90 \
 	zdf_oce.F90 \
@@ -10189,5 +10095,6 @@
 	$(MODEL_LIB)(trdmld_oce.o) \
 	$(MODEL_LIB)(trdvor_oce.o) \
-	$(MODEL_LIB)(zdf_oce.o) \
+	$(MODEL_LIB)(zdfddm.o) \
+	$(MODEL_LIB)(zdfmxl.o) \
 	$(MODEL_LIB)(zpshde.o) \
 	oce.F90 \
@@ -10200,5 +10107,6 @@
 	trdmld_oce.F90 \
 	trdvor_oce.F90 \
-	zdf_oce.F90 \
+	zdfddm.F90 \
+	zdfmxl.F90 \
 	zpshde.F90 \
 	daymod.F90 \
@@ -10311,4 +10219,5 @@
 	in_out_manager.F90 \
 	iom.F90 \
+	lbcnfd.F90 \
 	lib_mpp.F90 \
 	lib_print.f90 \
@@ -10317,4 +10226,5 @@
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(iom.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
 	$(MODEL_LIB)(lib_print.o) \
@@ -10374,65 +10284,13 @@
 	KEY_CPP \
 	trdvor_oce.F90
-$(MODEL_LIB)(wzvmod.o) :	\
-	bdy_oce.F90 \
-	bdy_par.F90 \
-	dom_oce.F90 \
-	dynspg_oce.F90 \
-	in_out_manager.F90 \
-	lbclnk.F90 \
-	lib_mpp.F90 \
-	lib_print.f90 \
-	$(MODEL_LIB)(bdy_oce.o) \
-	$(MODEL_LIB)(bdy_par.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(dynspg_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(lib_mpp.o) \
-	$(MODEL_LIB)(lib_print.o) \
-	$(MODEL_LIB)(obc_par.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(par_kind.o) \
-	$(MODEL_LIB)(par_oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(sbc_oce.o) \
-	obc_par.F90 \
-	oce.F90 \
-	par_kind.F90 \
-	par_oce.F90 \
-	phycst.F90 \
-	sbc_oce.F90 \
-	bdy_oce.F90 \
-	dom_oce.F90 \
-	domvvl.F90 \
-	in_out_manager.F90 \
-	lbclnk.F90 \
-	$(MODEL_LIB)(bdy_oce.o) \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(domvvl.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
-	$(MODEL_LIB)(obc_oce.o) \
-	$(MODEL_LIB)(obc_par.o) \
-	$(MODEL_LIB)(oce.o) \
-	$(MODEL_LIB)(phycst.o) \
-	$(MODEL_LIB)(prtctl.o) \
-	$(MODEL_LIB)(sbc_oce.o) \
-	obc_oce.F90 \
-	obc_par.F90 \
-	oce.F90 \
-	phycst.F90 \
-	prtctl.F90 \
-	sbc_oce.F90 \
-	domzgr_substitute.h90 \
-	KEY_CPP \
-	wzvmod.F90
 $(MODEL_LIB)(zdfbfr.o) :	\
 	dom_oce.F90 \
 	in_out_manager.F90 \
-	lib_mpp.F90 \
-	lib_print.f90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
+	lbcnfd.F90 \
+	lib_mpp.F90 \
+	lib_print.f90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
 	$(MODEL_LIB)(lib_print.o) \
@@ -10461,8 +10319,10 @@
 	dom_oce.F90 \
 	in_out_manager.F90 \
-	lib_mpp.F90 \
-	lib_print.f90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
+	lbcnfd.F90 \
+	lib_mpp.F90 \
+	lib_print.f90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
 	$(MODEL_LIB)(lib_print.o) \
@@ -10492,5 +10352,10 @@
 	eosbn2.F90 \
 	in_out_manager.F90 \
-	lbclnk.F90 \
+	iom_def.F90 \
+	iom_ioipsl.F90 \
+	iom_nf90.F90 \
+	iom_rstdimg.F90 \
+	lbclnk.F90 \
+	lbcnfd.F90 \
 	lib_mpp.F90 \
 	lib_print.f90 \
@@ -10498,5 +10363,10 @@
 	$(MODEL_LIB)(eosbn2.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(iom_def.o) \
+	$(MODEL_LIB)(iom_ioipsl.o) \
+	$(MODEL_LIB)(iom_nf90.o) \
+	$(MODEL_LIB)(iom_rstdimg.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
 	$(MODEL_LIB)(lib_print.o) \
@@ -10521,7 +10391,9 @@
 	dom_oce.F90 \
 	in_out_manager.F90 \
-	lbclnk.F90 \
-	$(MODEL_LIB)(dom_oce.o) \
-	$(MODEL_LIB)(in_out_manager.o) \
+	iom.F90 \
+	lbclnk.F90 \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(lbclnk.o) \
 	$(MODEL_LIB)(oce.o) \
@@ -10535,19 +10407,33 @@
 	zdfevd.F90
 $(MODEL_LIB)(zdfini.o) :	\
-	dom_oce.F90 \
+	c1d.F90 \
+	dom_oce.F90 \
+	domvvl.F90 \
 	dynzdf_exp.F90 \
 	eosbn2.F90 \
 	in_out_manager.F90 \
-	iom.F90 \
-	lbclnk.F90 \
+	iom_def.F90 \
+	iom.F90 \
+	iom_ioipsl.F90 \
+	iom_nf90.F90 \
+	iom_rstdimg.F90 \
+	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldfdyn_oce.F90 \
 	ldftra_oce.F90 \
 	lib_print.f90 \
-	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(c1d.o) \
+	$(MODEL_LIB)(dom_oce.o) \
+	$(MODEL_LIB)(domvvl.o) \
 	$(MODEL_LIB)(dynzdf_exp.o) \
 	$(MODEL_LIB)(eosbn2.o) \
 	$(MODEL_LIB)(in_out_manager.o) \
-	$(MODEL_LIB)(iom.o) \
-	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(iom_def.o) \
+	$(MODEL_LIB)(iom_ioipsl.o) \
+	$(MODEL_LIB)(iom_nf90.o) \
+	$(MODEL_LIB)(iom.o) \
+	$(MODEL_LIB)(iom_rstdimg.o) \
+	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
@@ -10561,4 +10447,5 @@
 	$(MODEL_LIB)(sbc_oce.o) \
 	$(MODEL_LIB)(trazdf_exp.o) \
+	$(MODEL_LIB)(trdmld_oce.o) \
 	$(MODEL_LIB)(trdmod.o) \
 	$(MODEL_LIB)(trdmod_oce.o) \
@@ -10567,4 +10454,5 @@
 	$(MODEL_LIB)(zdfmxl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
+	$(MODEL_LIB)(zpshde.o) \
 	oce.F90 \
 	par_kind.F90 \
@@ -10575,4 +10463,5 @@
 	sbc_oce.F90 \
 	trazdf_exp.F90 \
+	trdmld_oce.F90 \
 	trdmod.F90 \
 	trdmod_oce.F90 \
@@ -10581,5 +10470,7 @@
 	zdfmxl.F90 \
 	zdf_oce.F90 \
-	in_out_manager.F90 \
+	zpshde.F90 \
+	in_out_manager.F90 \
+	iom.F90 \
 	ldfdyn_oce.F90 \
 	ldfslp.F90 \
@@ -10587,4 +10478,5 @@
 	lib_mpp.F90 \
 	$(MODEL_LIB)(in_out_manager.o) \
+	$(MODEL_LIB)(iom.o) \
 	$(MODEL_LIB)(ldfdyn_oce.o) \
 	$(MODEL_LIB)(ldfslp.o) \
@@ -10592,4 +10484,5 @@
 	$(MODEL_LIB)(lib_mpp.o) \
 	$(MODEL_LIB)(par_oce.o) \
+	$(MODEL_LIB)(restart.o) \
 	$(MODEL_LIB)(tranpc.o) \
 	$(MODEL_LIB)(zdfddm.o) \
@@ -10598,7 +10491,8 @@
 	$(MODEL_LIB)(zdf_oce.o) \
 	$(MODEL_LIB)(zdfric.o) \
-	$(MODEL_LIB)(zdftke2.o) \
 	$(MODEL_LIB)(zdftke.o) \
-	par_oce.F90 \
+	$(MODEL_LIB)(zdftke_old.o) \
+	par_oce.F90 \
+	restart.F90 \
 	tranpc.F90 \
 	zdfddm.F90 \
@@ -10607,6 +10501,6 @@
 	zdf_oce.F90 \
 	zdfric.F90 \
-	zdftke2.F90 \
 	zdftke.F90 \
+	zdftke_old.F90 \
 	zdfini.F90
 $(MODEL_LIB)(zdfkpp.o) :	\
@@ -10614,4 +10508,5 @@
 	in_out_manager.F90 \
 	lbclnk.F90 \
+	lbcnfd.F90 \
 	ldftra_oce.F90 \
 	lib_mpp.F90 \
@@ -10620,4 +10515,5 @@
 	$(MODEL_LIB)(in_out_manager.o) \
 	$(MODEL_LIB)(lbclnk.o) \
+	$(MODEL_LIB)(lbcnfd.o) \
 	$(MODEL_LIB)(ldftra_oce.o) \
 	$(MODEL_LIB)(lib_mpp.o) \
